<?xml version="1.0" ?>

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fo="http://www.w3.org/1999/XSL/Format">
  <xsl:output indent="yes"/>

  <xsl:template match="/">
   <xsl:apply-templates />
  </xsl:template>

  <xsl:template match="bibliography">
    <fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">

      <!-- PAPIER A4 -->
      <fo:layout-master-set>
        <fo:simple-page-master master-name="A4"
           page-width="210mm"  page-height="297mm"
           margin-top="0.5in"  margin-bottom="0.5in"
           margin-left="0.5in" margin-right="0.5in">
          <fo:region-before extent="1.0in" />
          <fo:region-body margin-top="0.5in"
                          margin-bottom="0.5in"/>
          <fo:region-after extent="0.5in" />
        </fo:simple-page-master>
      </fo:layout-master-set>

      <fo:page-sequence master-reference="A4" initial-page-number="1">

        <!-- EN TETE -->
        <fo:static-content flow-name="xsl-region-before">
          <fo:block font-size="10pt" font-family="Times" line-height="10pt">
	  	<xsl:text>Generated by Transmorpher</xsl:text>
          </fo:block>
          <fo:block line-height="10pt">
            <fo:leader leader-length="10cm" leader-pattern="rule"
                       rule-thickness="1pt" color="black"/>
          </fo:block>
        </fo:static-content>

        <!-- PIED DE PAGE -->
        <fo:static-content flow-name="xsl-region-after">
          <fo:block text-align="right">
            <fo:page-number/>
          </fo:block>
        </fo:static-content>

        <!-- CORPS -->
        <fo:flow flow-name="xsl-region-body">
          <fo:block font-size="12pt" font-family="Times" line-height="12pt"
                    text-align="justify" space-after="50pt">
		    <xsl:apply-templates />          
	</fo:block>

        </fo:flow>
      </fo:page-sequence>

    </fo:root>
  </xsl:template>
  
  <xsl:template match="reference">
	   <xsl:apply-templates select="authors"/>
	   <xsl:apply-templates select="title"/>
	   <xsl:apply-templates select="links/url"/>
	   <xsl:apply-templates select="abstract"/>
  </xsl:template>
  
   <xsl:template match="authors">
   	<fo:block font-size="12pt" font-family="Times" line-height="12pt"
                    text-align="justify" font-weight="bold" space-after="5pt">
   	   <xsl:apply-templates select="p"/>
	   </fo:block>
  </xsl:template>
  
  <xsl:template match="abstract">
   	   <fo:block font-size="10pt" font-family="Times" line-height="12pt"
                    margin-left="20pt" margin-right="20pt" text-align="justify" font-style="italic" space-after="20pt">
		       	   <xsl:value-of select="."/>
			   
          </fo:block>
  </xsl:template>
  
  <xsl:template match="url">
   	<fo:block font-size="12pt" font-family="Times" line-height="20pt"
                    text-align="justify" space-after="5pt">
		       	   <fo:basic-link color="blue">
			   	<xsl:attribute name="external-destination">
					<xsl:value-of select="@href"/>
				</xsl:attribute>
				<xsl:value-of select="@href"/>
			</fo:basic-link>
          </fo:block>
  </xsl:template>
  
   <xsl:template match="title">
   	<fo:block font-size="18pt" font-family="Times" line-height="20pt"
                    text-align="justify" font-weight="bold" space-after="5pt">
		       	   <xsl:value-of select="."/>
          </fo:block>
  </xsl:template>
  
  <xsl:template match="p">
   	
   	<xsl:value-of select="@first" /><xsl:text> </xsl:text><xsl:value-of select="@last" /><xsl:text> </xsl:text>
	
  </xsl:template>
  
  </xsl:stylesheet>
