<?xml version="1.0" encoding="iso-8859-1" standalone="yes" ?>
<!-- $Id: form-exmo.xsl,v 1.6 2007/03/08 11:21:47 euzenat Exp $ -->

<!-- This stylesheet defines the HTML header format for the whole Exmo site -->

<xsl:stylesheet version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:bib="http://www.inrialpes.fr/exmo/papers"
 xmlns:datext="http://www.jclark.com/xt/java/java.util.Date"
 xmlns:datexa="xalan://java.util.Date">

<xsl:output
  method="xml"
  encoding="iso-8859-1"
  omit-xml-declaration="no"
  standalone="yes"
  doctype-public="-//IETF//DTD HTML//EN"
  indent="yes"/> 

<xsl:template match="/" mode="exmo">

<html>
  <head><title>Exmo bibliography selection</title>
  </head>
  <body bgcolor="ffffff">
    <p><a href="http://exmo.inrialpes.fr"><img src="img/exmo-small.gif" alt=" [EXMO] " border="0" align="bottom" /></a></p>
    <form action="BiblioServlet" method="post">
      <input type="hidden" name="file" value="bibexmo.xml" />
      <input type="hidden" name="layout" value="exmo" />
      <table width="100%">
	<tr border="0">
	  <td bgcolor="#99ccff" width="50%">
	    <xsl:text> sorted by </xsl:text><select name="sort">
	      <option value="ay"><xsl:if test="$sort='ay'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Authors, years</option>
	      <option value="ty"><xsl:if test="$sort='ty'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Areas, year</option>
	      <option value="ya"><xsl:if test="$sort='ya'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Year, authors</option>
	      <option value="cya"><xsl:if test="$sort='cya'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>Type, year, author</option>
	    </select>
	  </td>
	  <td bgcolor="#00ffcc" width="40%">
	    <xsl:text> in </xsl:text><select name="format">
	      <option value="html"><xsl:if test="$format='html'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>HTML</option>
	      <option value="pdf"><xsl:if test="$format='pdf'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>PDF</option>
	      <!--option value="ps"><xsl:if test="$format='ps'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>PostScript</option-->
	      <option value="rtf"><xsl:if test="$format='rtf'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>RTF</option>
	      <option value="bib"><xsl:if test="$format='bib'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>BibTeX</option>
	      <!--option value="rdf"><xsl:if test="$format='rdf'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>RDF</option-->
	      <option value="xml"><xsl:if test="$format='xml'"><xsl:attribute name="selected">true</xsl:attribute></xsl:if>XML</option>
	    </select><xsl:text> without abstract </xsl:text>
	    <input type="checkbox" name="abstrip">
	      <xsl:if test="$abstrip='on'">
		<xsl:attribute name="checked">true</xsl:attribute>
	      </xsl:if>
	    </input>
	  </td>
	  <td bgcolor="#cc00cc" width="10%">
	    <input type="submit" value="OK" />
	  </td>
	</tr>
      </table>
    </form>
    <xsl:apply-templates/>
    <hr />
    <table width="100%">
      <tr border="1"><td>
	  <small>
	    <a href="http://exmo.inrialpes.fr">EXMO</a> :
	    <a href="http://exmo.inrialpes.fr/research">research</a> | 
	    <a href="http://exmo.inrialpes.fr/people">people</a> | 
	    <a href="http://exmo.inrialpes.fr/papers">papers</a> | 
	    <a href="http://exmo.inrialpes.fr/teaching">teaching</a> | 
	    <a href="http://exmo.inrialpes.fr/training">training</a> | 
	    <a href="http://exmo.inrialpes.fr/cooperation">cooperation</a> | 
	    <a href="http://exmo.inrialpes.fr/software">software</a> | 
	    <a href="http://exmo.inrialpes.fr/applications">applications</a> | 
	    <a href="http://exmo.inrialpes.fr/transfert">transfer</a>
	  </small>
	</td><td align="right">
	  <small><a href="http://exmo.inrialpes.fr/notice.html" alt=" [legal notice] "></a> |
	    <a href="http://exmo.inrialpes.fr/search.html" alt=" [search] ">?</a> |
	    <a href="http://exmo.inrialpes.fr/gloss.html" alt=" [glossary] ">*</a>
	  </small>
    </td></tr></table>
    <hr />
    <table width="100%"><tr><td>
	  <small>http://exmo.inrialpes.fr/papers/</small>
	</td><td align="right">
	  <small>
	    <a href="http://exmo.inrialpes.fr/notice.html"> INRIA Rhne-Alpes,
	      1999-2001, 2003, 2005, 2007</a>
	  </small>
    </td></tr></table>
    <hr />
    <address>Maintained by Jrme Euzenat; Generated by <a href="http://transmorpher.gforge.inria.fr">Transmorpher</a>
      <!-- for XT -->
      <xsl:choose>
	<xsl:when test="function-available('datext:to-string') and function-available('datext:new')">
	   on <xsl:value-of select="datext:to-string(datext:new())"/>
	</xsl:when>
        <!-- for Xalan -->
        <xsl:when test="function-available('datexa:toString') and function-available('datexa:new')">
	   on <xsl:value-of select="datexa:toString(datexa:new())"/>
	</xsl:when>
      </xsl:choose>
    </address>
  </body>
</html>

</xsl:template>

</xsl:stylesheet>
