<?xml version="1.0" encoding="iso-8859-1" standalone="no" ?>
<!-- $Id: form-fo.xsl,v 1.7 2007/03/08 11:21:47 euzenat Exp $ -->

<!-- DOCTYPE xsl:stylesheet SYSTEM ""-->

<!-- This stylesheet defines the FO formats for pages and reference.
     It is called by the other form-fXXXX.xsl stylesheet for adding the 
     grouping information by the main sorting key -->

<xsl:stylesheet version="1.0"
  xmlns:datext="http://www.jclark.com/xt/java/java.util.Date"
  xmlns:datexa="xalan://java.util.Date"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:bib="http://www.inrialpes.fr/exmo/papers"
  xmlns:fo="http://www.w3.org/1999/XSL/Format">

  <xsl:import href="common.xsl" />

  <xsl:template match="/">
    <xsl:apply-templates />
  </xsl:template>

  <xsl:template match="bibliography">
    <fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">

      <!-- PAPIER A4 -->
      <fo:layout-master-set>
        <fo:simple-page-master master-name="A4"
           page-width="210mm"  page-height="297mm"
           margin-top="0.5in"  margin-bottom="0.5in"
           margin-left="0.5in" margin-right="0.5in">
          <fo:region-before extent="1.0in" />
          <fo:region-body margin-top="0.5in"
                          margin-bottom="0.5in"/>
          <fo:region-after extent="0.5in" />
        </fo:simple-page-master>
      </fo:layout-master-set>

      <fo:page-sequence master-reference="A4" initial-page-number="1">

        <!-- EN TETE -->
        <fo:static-content flow-name="xsl-region-before">
          <fo:block line-height="10pt">
            <fo:leader leader-length="19.5cm" leader-pattern="rule"
                       rule-thickness="1pt" color="black"/>
          </fo:block>
        </fo:static-content>

        <!-- PIED DE PAGE -->
        <fo:static-content flow-name="xsl-region-after">
          <fo:block text-align="left">
	  	<xsl:value-of select="@name"/><xsl:text> </xsl:text>
	  	(version <xsl:value-of select="@version"/>)
          </fo:block>
          <fo:block text-align="right">
            <fo:page-number/>
          </fo:block>
        </fo:static-content>

        <!-- CORPS -->
        <fo:flow flow-name="xsl-region-body" font-size="12pt"
		 font-family="Times" line-height="15pt"
                 text-align="justify" space-after="50pt">
          <fo:block font-size="14pt">
		    <xsl:value-of select="@name"/> (<xsl:value-of select="@date"/>)
	  </fo:block>
	    <xsl:apply-templates />    
          <fo:block line-height="10pt">
            <fo:leader leader-length="15cm" leader-pattern="rule"
                       rule-thickness="1pt" color="black"/>
          </fo:block>
          <fo:block font-size="9pt" font-family="Times" line-height="9pt">
            <xsl:text>

Generated by Transmorpher</xsl:text>
            <!-- for XT -->
	    <xsl:if test="function-available('datext:to-string') and function-available('datext:new')">
	      <xsl:text> on </xsl:text><xsl:value-of select="datext:to-string(datext:new())"/>
	    </xsl:if>
            <!-- for Xalan -->
            <xsl:if test="function-available('datexa:toString')">
	      <xsl:text> on </xsl:text><xsl:value-of select="datexa:toString(datexa:new())"/>
	    </xsl:if>
          </fo:block>
        </fo:flow>
      </fo:page-sequence>

    </fo:root>
  </xsl:template>
  
  <xsl:template match="reference" mode="linear">
    <xsl:choose>
      <xsl:when test="authors|directors|scenarists|interprets|voices">
	<xsl:apply-templates select="authors|directors|scenarists|interprets|voices" mode="linear">
          <xsl:with-param name="language" select="@language"/>
	</xsl:apply-templates>
      </xsl:when>
      <xsl:when test="editors">
	<xsl:apply-templates select="editors" mode="linear">
          <xsl:with-param name="language" select="@language"/>
	</xsl:apply-templates>
      </xsl:when>
    </xsl:choose>
    <xsl:call-template name="gettitle"/><xsl:text>, </xsl:text>
    <xsl:apply-templates select="." mode="line3"/>
  </xsl:template>

  <xsl:template match="reference" mode="line3">
    <xsl:choose>
      <xsl:when test="@type='article' or @type='specialissue' or @type='recension' or @type='bulletin'">
	<fo:inline font-style="italic"><xsl:value-of select="journal/@name"/></fo:inline>
	<xsl:if	test="@type='specialissue'"><xsl:text> </xsl:text><xsl:choose><xsl:when
			test="@language='fr'">(numro spcial)</xsl:when>
			      <xsl:otherwise>(special issue)</xsl:otherwise>
                  </xsl:choose></xsl:if>
	<xsl:if test="volume"><xsl:text> </xsl:text><xsl:value-of select="volume/text()"/></xsl:if>
	<xsl:if test="number">(<xsl:value-of select="number/text()"/>)</xsl:if>
	<xsl:if test="pages">:<xsl:value-of select="pages/text()"/></xsl:if>
	<xsl:text>, </xsl:text>
        <xsl:value-of select="date/@year"/>
      </xsl:when>
      <xsl:when test="@type='unpublished'">
	Unpublished <xsl:if test="date/@year"><xsl:text>, </xsl:text><xsl:value-of select="date/@year"/></xsl:if>
      </xsl:when>
      <xsl:when test="@type='prospective' or @type='techreport' or @type='internalreport'">
	<xsl:choose>
	  <xsl:when test="type"><xsl:value-of select="type/text()"/></xsl:when>
	  <xsl:when test="@type='techreport'">Technical report</xsl:when>
	  <xsl:when test="@type='prospective'">Prospective report</xsl:when>
	  <xsl:when test="@type='internalreport'">Internal report</xsl:when>
	</xsl:choose>
	<xsl:if test="number"><xsl:text> </xsl:text><xsl:value-of select="number/text()"/></xsl:if>
	<xsl:text>, </xsl:text>
	<xsl:if test="institution">
	  <xsl:value-of select="institution/@name"/><xsl:text>, </xsl:text>
	  <xsl:if test="institution/location">
	    <xsl:apply-templates select="institution/location"/><xsl:text>, </xsl:text>
	  </xsl:if>
	</xsl:if>
        <xsl:if test="length and (length/@unit='p')">
          <xsl:value-of select="length/text()"/><xsl:text>p., </xsl:text>
	</xsl:if>
	<xsl:if test="date/@month">
	  <xsl:call-template name="codemonth">
            <xsl:with-param name="month" select="date/@month"/>
            <xsl:with-param name="language" select="@language"/>
          </xsl:call-template><xsl:text> </xsl:text>
	</xsl:if>
	<xsl:value-of select="date/@year"/>
      </xsl:when>
      <xsl:when test="@type='deliverable'">
	<xsl:choose>
	  <xsl:when test="type"><xsl:value-of select="type/text()"/></xsl:when>
	  <xsl:otherwise>Deliverable</xsl:otherwise>
	</xsl:choose>
	<xsl:if test="number"><xsl:text> </xsl:text><xsl:value-of select="number/text()"/></xsl:if>
	<xsl:text>, </xsl:text>
	<xsl:if test="contract">
          <xsl:value-of select="contract/text()"/><xsl:text>, </xsl:text>
	</xsl:if>
	<xsl:if test="institution">
	  <xsl:value-of select="institution/@name"/><xsl:text>, </xsl:text>
	  <xsl:if test="institution/location">
	    <xsl:apply-templates select="institution/location"/><xsl:text>, </xsl:text>
	  </xsl:if>
	</xsl:if>
        <xsl:if test="length and (length/@unit='p')">
          <xsl:value-of select="length/text()"/><xsl:text>p., </xsl:text>
	</xsl:if>
	<xsl:if test="date/@month">
	  <xsl:call-template name="codemonth">
            <xsl:with-param name="month" select="date/@month"/>
            <xsl:with-param name="language" select="@language"/>
	  </xsl:call-template>
	</xsl:if>
	<xsl:value-of select="date/@year"/>
      </xsl:when>
	<xsl:when test="@type='mastersthesis'">
	  <xsl:choose>
	    <xsl:when test="type"><xsl:value-of select="type/text()"/></xsl:when>
	    <xsl:otherwise>Master thesis</xsl:otherwise>
	  </xsl:choose>
	  <xsl:if test="number"><xsl:text> </xsl:text><xsl:value-of select="number/text()"/></xsl:if>
	  <xsl:text>, </xsl:text>
	  <xsl:if test="school">
	    <xsl:value-of select="school/@name"/><xsl:text>, </xsl:text>
	    <xsl:if test="school/location">
	      <xsl:apply-templates select="school/location"/><xsl:text>, </xsl:text>
	    </xsl:if>
	  </xsl:if>
          <xsl:if test="length and (length/@unit='p')">
            <xsl:value-of select="length/text()"/><xsl:text>p., </xsl:text>
	  </xsl:if>
	  <xsl:if test="date/@month">
	    <xsl:call-template name="codemonth">
              <xsl:with-param name="month" select="date/@month"/>
              <xsl:with-param name="language" select="@language"/>
	    </xsl:call-template>
	  </xsl:if>
	  <xsl:value-of select="date/@year"/>
	</xsl:when>
	<xsl:when test="@type='phd'">
	  <xsl:choose>
	    <xsl:when test="type"><xsl:value-of select="type/text()"/></xsl:when>
	    <xsl:otherwise>PhD thesis</xsl:otherwise>
	  </xsl:choose>
	  <xsl:if test="number"><xsl:text> </xsl:text><xsl:value-of select="number/text()"/></xsl:if>
	  <xsl:text>, </xsl:text>
	  <xsl:if test="school">
	    <xsl:value-of select="school/@name"/><xsl:text>, </xsl:text>
	    <xsl:if test="school/location">
	      <xsl:apply-templates select="school/location"/><xsl:text>, </xsl:text>
	    </xsl:if>
	  </xsl:if>
          <xsl:if test="length and (length/@unit='p')">
            <xsl:value-of select="length/text()"/><xsl:text>p., </xsl:text>
	  </xsl:if>
	  <xsl:if test="date/@month">
	    <xsl:call-template name="codemonth">
              <xsl:with-param name="month" select="date/@month"/>
              <xsl:with-param name="language" select="@language"/>
	    </xsl:call-template>
	  </xsl:if>
	  <xsl:value-of select="date/@year"/>
	</xsl:when>
	<xsl:when test="@type='proceedings'"> <!-- OR confernce -->
	  <xsl:choose>
	    <xsl:when test="publisher">
	      <xsl:value-of select="publisher/@name"/><xsl:text>, </xsl:text>
	      <xsl:if test="publisher/location">
		<xsl:apply-templates select="publisher/location"/><xsl:text>, </xsl:text>
	      </xsl:if>
	    </xsl:when>
	    <xsl:when test="institution">
	      <xsl:value-of select="institution/@name"/><xsl:text>, </xsl:text>
	      <xsl:if test="institution/location">
		<xsl:apply-templates select="institution/location"/><xsl:text>, </xsl:text>
	      </xsl:if>
	    </xsl:when>
	  </xsl:choose>
          <xsl:if test="length and (length/@unit='p')">
            <xsl:value-of select="length/text()"/><xsl:text>p., </xsl:text>
	  </xsl:if>
	  <xsl:value-of select="date/@year"/>
	</xsl:when>
	<xsl:when test="@type='manual'">
	  <xsl:choose>
	    <xsl:when test="type"><xsl:value-of select="type/text()"/></xsl:when>
	    <xsl:otherwise>Manual</xsl:otherwise>
	  </xsl:choose>
	  <xsl:if test="edition"><xsl:text> (</xsl:text><xsl:value-of select="edition"/>
            <xsl:choose><xsl:when test="@language='fr'">d</xsl:when>
	      <xsl:otherwise>ed</xsl:otherwise>
            </xsl:choose><xsl:text>.)</xsl:text>
          </xsl:if>
          <xsl:text>, </xsl:text>
	  <xsl:if test="institution">
	    <xsl:value-of select="institution/@name"/><xsl:text>, </xsl:text>
	    <xsl:if test="institution/location">
	      <xsl:apply-templates select="institution/location"/><xsl:text>, </xsl:text>
	    </xsl:if>
	  </xsl:if>
          <xsl:if test="length and (length/@unit='p')">
            <xsl:value-of select="length/text()"/><xsl:text>p., </xsl:text>
	  </xsl:if>
	  <xsl:if test="date/@month">
	    <xsl:call-template name="codemonth">
              <xsl:with-param name="month" select="date/@month"/>
              <xsl:with-param name="language" select="@language"/>
	    </xsl:call-template>
	  </xsl:if>
	  <xsl:value-of select="date/@year"/>
	</xsl:when>
	<xsl:when test="@type='inproceedings'">
          <xsl:if test="editors">
            <xsl:apply-templates select="editors" mode="linear">
              <xsl:with-param name="language" select="@language"/>
            </xsl:apply-templates>
          </xsl:if>
	  <xsl:apply-templates select="conference">
            <xsl:with-param name="language" select="@language"/>
	  </xsl:apply-templates>
	  <xsl:if test="in">
            <xsl:text>(</xsl:text>
            <xsl:apply-templates select="in/reference" mode="linear"/><xsl:text>), </xsl:text>
	  </xsl:if>
	  <xsl:if test="red">
            <xsl:text>(rev. </xsl:text>
            <xsl:apply-templates select="red/reference" mode="linear"/><xsl:text>), </xsl:text>
	  </xsl:if>
	  <xsl:if test="pages">
	    <xsl:text>pp</xsl:text>
	    <xsl:value-of select="pages/text()"/>
	    <xsl:text>, </xsl:text>
	  </xsl:if>
          <xsl:if test="date/@month"><xsl:text>(</xsl:text>
            <xsl:if test="date/@day">
	      <xsl:value-of select="date/@day"/><xsl:text> </xsl:text>
	    </xsl:if>
	    <xsl:call-template name="codemonth">
              <xsl:with-param name="month" select="date/@month"/>
              <xsl:with-param name="language" select="@language"/>
	    </xsl:call-template>
	    <xsl:text>) </xsl:text>                                
          </xsl:if>
	  <xsl:value-of select="date/@year"/>
	</xsl:when>
	<xsl:when test="@type='incollection'">
	  <xsl:text>In: </xsl:text>
          <xsl:apply-templates select="in/reference" mode="linear"/>
          <xsl:text>, </xsl:text>
	  <xsl:if test="pages">
	    <xsl:text>pp</xsl:text>
	    <xsl:value-of select="pages/text()"/>
	  </xsl:if>
	</xsl:when>
	<xsl:when test="@type='inbook'">
	  <xsl:text>In: </xsl:text>
	  <xsl:if test="chapter">
	    <xsl:text>Chapter </xsl:text>
	    <xsl:value-of select="chapter/text()"/>
	    <xsl:text> of </xsl:text>
	  </xsl:if>
          <xsl:apply-templates select="in/reference" mode="linear"/>
          <xsl:text>, </xsl:text>
	  <xsl:if test="pages">
	    <xsl:text>pp</xsl:text>
	    <xsl:value-of select="pages/text()"/>
	  </xsl:if>
	</xsl:when>
	<xsl:when test="@type='booklet'">
	</xsl:when>
	<xsl:when test="@type='book' or @type='collection'">
          <xsl:if test="serie">
            <xsl:if test="@language='fr'">Collection </xsl:if><xsl:value-of select="serie/text()"/><xsl:if test="@language='en'"> series</xsl:if>
            <xsl:if test="number"><xsl:text> </xsl:text><xsl:value-of select="number/text()"/></xsl:if>
            <xsl:text>, </xsl:text>
          </xsl:if>
	  <xsl:value-of select="publisher/@name"/>
	  <xsl:text>, </xsl:text>
	  <xsl:if test="publisher/location">
	    <xsl:apply-templates select="publisher/location"/><xsl:text>, </xsl:text>
	  </xsl:if>
          <xsl:if test="length and (length/@unit='p')">
            <xsl:value-of select="length/text()"/><xsl:text>p., </xsl:text>
          </xsl:if>
	  <xsl:if test="red">
            <xsl:text>(rev. </xsl:text>
            <xsl:apply-templates select="red/reference" mode="linear"/><xsl:text>), </xsl:text>
	  </xsl:if>
	  <xsl:if test="trad">
            <xsl:text>(trad. </xsl:text><xsl:value-of select="trad/@language"/>
            <xsl:apply-templates select="trad/reference" mode="linear"/><xsl:text>), </xsl:text>
	  </xsl:if>
	  <xsl:value-of select="date/@year"/>
	</xsl:when>
	<xsl:when test="@type='misc'">
	  <xsl:if test="type"><xsl:value-of select="type/text()"/><xsl:text>, </xsl:text></xsl:if>
	  <xsl:if test="institution">
	    <xsl:value-of select="institution/@name"/><xsl:text>, </xsl:text>
	    <xsl:if test="institution/location">
	      <xsl:apply-templates select="institution/location"/><xsl:text>, </xsl:text>
	    </xsl:if>
	  </xsl:if>
          <xsl:if test="length and (length/@unit='p')">
            <xsl:value-of select="length/text()"/><xsl:text>p., </xsl:text>
	  </xsl:if>
	  <xsl:if test="date/@month">
	    <xsl:call-template name="codemonth">
              <xsl:with-param name="month" select="date/@month"/>
              <xsl:with-param name="language" select="@language"/>
	    </xsl:call-template>
	  </xsl:if>
	  <xsl:value-of select="date/@year"/>
	</xsl:when>
	<xsl:when test="@type='lecturenotes'">
	  <xsl:choose>
	    <xsl:when test="type"><xsl:value-of select="type/text()"/></xsl:when>
	    <xsl:when test="@language='fr'">Notes de cours</xsl:when>
	    <xsl:when test="@language='en'">Lecture notes</xsl:when>
	  </xsl:choose>
	  <xsl:text>, </xsl:text>
	  <xsl:if test="school">
	    <xsl:value-of select="school/@name"/><xsl:text>, </xsl:text>
	    <xsl:if test="school/location">
	      <xsl:apply-templates select="school/location"/><xsl:text>, </xsl:text>
	    </xsl:if>
	  </xsl:if>
          <xsl:if test="length and (length/@unit='p')">
            <xsl:value-of select="length/text()"/><xsl:text>p., </xsl:text>
	  </xsl:if>
	  <xsl:if test="date/@month">
	    <xsl:call-template name="codemonth">
              <xsl:with-param name="month" select="date/@month"/>
              <xsl:with-param name="language" select="@language"/>
	    </xsl:call-template>
	  </xsl:if>
	  <xsl:value-of select="date/@year"/>
	</xsl:when>
	<xsl:when test="@type='motionpicture'">
	  <xsl:if test="institution">
	    <xsl:value-of select="institution/@name"/><xsl:text>, </xsl:text>
	    <xsl:if test="institution/location">
	      <xsl:apply-templates select="institution/location"/><xsl:text>, </xsl:text>
	    </xsl:if>
	  </xsl:if>
          <xsl:if test="length and (length/@unit='mn')">
            <xsl:value-of select="length/text()"/><xsl:text>mn, </xsl:text>
	  </xsl:if>
	  <xsl:if test="date/@month">
	    <xsl:call-template name="codemonth">
              <xsl:with-param name="month" select="date/@month"/>
              <xsl:with-param name="language" select="@language"/>
	    </xsl:call-template>
	  </xsl:if>
	  <xsl:value-of select="date/@year"/>
	</xsl:when>
	<xsl:when test="@type='serialproceedings'">
	  <fo:inline font-style="italic"><xsl:value-of select="journal/@name"/></fo:inline>
	  <xsl:if test="volume"><xsl:text> </xsl:text><xsl:value-of select="volume/text()"/></xsl:if>
	  <xsl:if test="number">(<xsl:value-of select="number/text()"/>)</xsl:if>
	  <xsl:if test="pages">:<xsl:value-of select="pages/text()"/></xsl:if>
	  <xsl:text>, </xsl:text>
          <xsl:value-of select="date/@year"/>
	</xsl:when>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="conference">
    <xsl:param name="language"/>
    <xsl:call-template name="confname">
      <xsl:with-param name="conf" select="."/>
      <xsl:with-param name="language" select="$language"/>
    </xsl:call-template>
    <xsl:text>, </xsl:text>
    <xsl:if test="location">
      <xsl:apply-templates select="location"/><xsl:text>, </xsl:text>
    </xsl:if>
  </xsl:template>

  <!-- The full format for bibliographic entries -->

  <xsl:template match="reference">
    <fo:block font-family="Times" space-before="8pt">[<xsl:value-of select="@index"/>]  <xsl:choose>
	<xsl:when test="authors|directors|scenarists|interprets|voices">
	  <xsl:apply-templates select="authors|directors|scenarists|interprets|voices" mode="linear">
            <xsl:with-param name="language" select="@language"/>
	  </xsl:apply-templates>
	</xsl:when>
	<xsl:when test="editors">
	  <xsl:apply-templates select="editors" mode="linear">
            <xsl:with-param name="language" select="@language"/>
	  </xsl:apply-templates>
	</xsl:when>
      </xsl:choose>
    </fo:block>
    <fo:block font-family="Times" font-weight="bold" start-indent="0.5cm">
      <xsl:call-template name="gettitle"/><xsl:text>, </xsl:text>
    </fo:block><fo:block
      start-indent="0.5cm" font-family="Times"><xsl:apply-templates select="." mode="line3"/><xsl:if test="award"><fo:block font-style="italic" start-indent="1cm"><xsl:text> </xsl:text><xsl:value-of select="award/text()"/></fo:block></xsl:if></fo:block>
    <xsl:if test="note">
      <fo:block font-style="italic" start-indent="1cm"><xsl:text> </xsl:text><xsl:value-of select="note/text()"/></fo:block>
    </xsl:if>
    <xsl:apply-templates select="links"/>
    <xsl:if test="abstract">
      <fo:block font-size="10pt" font-family="Times" line-height="12pt"
                margin-left="20pt" margin-right="20pt" start-indent="1cm"
		text-align="justify" font-style="italic">
	<xsl:copy-of select="abstract/text()|abstract/*"/>
      </fo:block>
    </xsl:if>
    <xsl:if test="comments">
	<fo:block font-size="smaller" start-indent="1cm"><xsl:copy-of select="comments/text()"/></fo:block>
    </xsl:if>
    <!--xsl:if test="keywords">
      <font size="-1">
	<xsl:apply-templates select="keywords/li[1]"/>
	<xsl:for-each select="keywords/li[position()>1]">
	  <xsl:text>, </xsl:text><xsl:apply-templates select="."/>
	</xsl:for-each>
      </font><br />
    </xsl:if>
    <xsl:if test="areas">
      <xsl:apply-templates select="areas/li[1]"/>
      <xsl:for-each select="areas/li[position()>1]">
	<xsl:text>, </xsl:text><xsl:apply-templates select="."/>
      </xsl:for-each>
    </xsl:if-->
  </xsl:template>

<!-- template for a short presentation of the entries -->

<xsl:template match="reference" mode="short">
  <xsl:choose>
    <xsl:when test="authors|directors|scenarists|interprets|voices">
      <xsl:apply-templates select="authors|directors|scenarists|interprets|voices" mode="linear">
        <xsl:with-param name="language" select="@language"/>
      </xsl:apply-templates>
    </xsl:when>
    <xsl:when test="editors">
      <xsl:apply-templates select="editors" mode="linear">
        <xsl:with-param name="language" select="@language"/>
      </xsl:apply-templates>
    </xsl:when>
  </xsl:choose>
        <!--xsl:apply-templates select="." mode="short3"/-->
</xsl:template>

<!-- displaying people an lists of people -->

<xsl:template match="p">
	<xsl:value-of select="@title"/><xsl:text> </xsl:text>
	<xsl:value-of select="@first"/><xsl:text> </xsl:text>
	<xsl:value-of select="@last"/>
 </xsl:template>

<xsl:template match="authors" mode="linear">
  <xsl:for-each select="p">
	<xsl:apply-templates select="."/><xsl:text>, </xsl:text>
  </xsl:for-each>
</xsl:template>

<xsl:template name="listpeople">
	<xsl:apply-templates select="p[1]"/>
	<xsl:for-each select="p[position()>1]">
		<xsl:text>, </xsl:text>
		<xsl:apply-templates select="."/>
	</xsl:for-each>
</xsl:template>

<!-- this should implement the complete xxx scheme -->
<xsl:template match="editors" mode="linear">
  <xsl:param name="language"/>
  <xsl:apply-templates select="p[1]"/>
		<xsl:for-each select="p[position()>1]">
			<xsl:text>, </xsl:text>
			<xsl:apply-templates select="."/>
		</xsl:for-each>
		<xsl:choose><xsl:when test="$language='fr'"> (d</xsl:when>
			<xsl:when test="$language='de'"> (Hrsg</xsl:when>
			<xsl:otherwise> (ed</xsl:otherwise>
		</xsl:choose>
		<xsl:if test="p[2]">s</xsl:if>
		<xsl:text>), </xsl:text>
</xsl:template>
<xsl:template match="directors" mode="linear">
  <xsl:param name="language"/>
	<xsl:call-template name="listpeople"/>
	<xsl:choose><xsl:when test="$language='fr'"> (ralisateur</xsl:when>
		<xsl:when test="$language='de'"> (regiseur</xsl:when>
		<xsl:otherwise> (director</xsl:otherwise>
	</xsl:choose>
	<xsl:if test="p[2]">s</xsl:if>
	<xsl:text>), </xsl:text>
</xsl:template>
<xsl:template match="scenarists" mode="linear">
  <xsl:param name="language"/>
	<xsl:call-template name="listpeople"/>
	<xsl:choose><xsl:when test="$language='fr'"> (scnariste</xsl:when>
		<xsl:when test="$language='de'"> (scenarist</xsl:when>
		<xsl:otherwise> (scenarist</xsl:otherwise>
	</xsl:choose>
	<xsl:if test="p[2]">s</xsl:if>
	<xsl:text>), </xsl:text>
</xsl:template>
<xsl:template match="interprets" mode="linear">
  <xsl:param name="language"/>
	<xsl:call-template name="listpeople"/>
	<xsl:choose><xsl:when test="$language='fr'"> (acteur</xsl:when>
		<xsl:when test="$language='de'"> (actor</xsl:when>
		<xsl:otherwise> (actor</xsl:otherwise>
	</xsl:choose>
	<xsl:if test="p[2]">s</xsl:if>
	<xsl:text>), </xsl:text>
</xsl:template>
<xsl:template match="voices" mode="linear">
  <xsl:param name="language"/>
	<xsl:call-template name="listpeople"/>
	<xsl:choose><xsl:when test="$language='fr'"> (voix</xsl:when>
		<xsl:when test="$language='de'"> (voice</xsl:when>
		<xsl:otherwise> (voice</xsl:otherwise>
	</xsl:choose>
	<xsl:if test="p[2]">s</xsl:if>
	<xsl:text>), </xsl:text>
</xsl:template>

<!-- displaying an item: use FO facilities -->

<xsl:template match="li">
	<xsl:value-of select="text()"/>
</xsl:template>

  <!-- displaying a location -->

  <xsl:template match="location">
    <xsl:if test="@place"><xsl:value-of select="@place"/><xsl:text>, </xsl:text></xsl:if>
    <xsl:if test="@city"><xsl:value-of select="@city"/></xsl:if>
    <xsl:if test="@country"><xsl:text> (</xsl:text>
      <xsl:if test="@state"><xsl:value-of select="@state"/><xsl:text> </xsl:text></xsl:if>
      <xsl:value-of select="@country"/><xsl:text>)</xsl:text>
    </xsl:if>
  </xsl:template>

  <!-- displaying a link -->

  <xsl:template match="links">
    <fo:block space-after="5pt" line-height="12pt" start-indent="0.5cm">
      <xsl:apply-templates/>
    </fo:block>
  </xsl:template>

<!-- displaying an URL -->

  <xsl:template match="url">
    <fo:block start-indent="0.5cm" font-size="10pt" font-family="Courier">
      <fo:basic-link color="blue">
	<xsl:attribute name="external-destination">
 	  <xsl:value-of select="@href"/>
	</xsl:attribute>
	<fo:inline font-size="10pt" font-family="Courier">
	  <xsl:value-of select="@href"/>
	</fo:inline>
      </fo:basic-link>
    </fo:block>
  </xsl:template>

<!-- displaying the title of a reference -->
<xsl:template name="gettitle">
  <xsl:copy-of select="title/text()|title/*" />
  <xsl:if test="(@type='proceedings' or @type='serialproceedings') and conference">
    <xsl:text> (</xsl:text><xsl:call-template name="confname">
      <xsl:with-param name="language" select="@language"/>
      <xsl:with-param name="conf" select="conference"/>
    </xsl:call-template><xsl:text>)</xsl:text>
  </xsl:if>
</xsl:template>

<!-- displaying the name of a conference -->
<xsl:template name="confname">
  <xsl:param name="language"/>
  <xsl:param name="conf"/>
  <xsl:choose>
    <xsl:when test="$language='fr'"><xsl:text>Actes </xsl:text></xsl:when>
    <xsl:otherwise><xsl:text>Proc. </xsl:text></xsl:otherwise>
  </xsl:choose>
  <xsl:if test="$conf/@issue">
      <!-- RTF conversion does not understand "smaller" -->
      <xsl:value-of select="$conf/@issue"/><fo:inline baseline-shift="super" font-size="10pt">
        <xsl:call-template name="coderank">
          <xsl:with-param name="num" select="$conf/@issue"/>
          <xsl:with-param name="language" select="$language"/>
      </xsl:call-template></fo:inline>
    </xsl:if>
  <xsl:if test="$conf/@sponsor and $language='en'">
    <xsl:value-of select="$conf/@sponsor"/>
    <xsl:text> </xsl:text>
  </xsl:if>
  <xsl:choose>
    <xsl:when test="$conf/@type"><xsl:value-of select="$conf/@type"/></xsl:when>
    <xsl:otherwise><xsl:text>conference</xsl:text></xsl:otherwise>
  </xsl:choose>
  <xsl:text> </xsl:text>
  <xsl:if test="$conf/@sponsor and $language='fr'">
    <xsl:value-of select="$conf/@sponsor"/>
  </xsl:if>
  <xsl:if test="$conf/@name">
    <xsl:choose>
      <xsl:when test="$language='fr'"><xsl:text> sur </xsl:text></xsl:when>
      <xsl:otherwise><xsl:text> on </xsl:text></xsl:otherwise>
    </xsl:choose>
    <xsl:value-of select="$conf/@name"/>
  </xsl:if>
  <xsl:if test="$conf/@short">
    <xsl:text> (</xsl:text>
    <xsl:value-of select="$conf/@short"/>
    <xsl:text>)</xsl:text>
  </xsl:if>
</xsl:template>

<!-- by default, everything is copyied -->

<xsl:template match="*|@*|text()">
	<xsl:copy>
		<xsl:apply-templates select="*|@*|text()"/>
	</xsl:copy>
</xsl:template>



</xsl:stylesheet>
