/**
 * $Id: LinearIndexedStruct.java,v 1.1 2002/11/06 14:08:21 serge Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/** define a general-purpose structure whose elements are accessible
    both through a hashtable and a linear order
*/

package fr.fluxmedia.transmorpher.utils ;

// import java classes
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.LinkedList;
import java.util.ListIterator;

public class LinearIndexedStruct {
 
  /** The list of unlinked out  XML_Port */
  Hashtable table = null;
  LinkedList list = null;
  int last = 0;
    
  public LinearIndexedStruct() {
    table = new Hashtable();
    list = new LinkedList();
  }

  public void clear(){
    table.clear();
    list.clear();
    last = 0;
  }
    
  public Object get(String name){
    return table.get(name);
  }

  public Object get(int i){
    return list.get(i);
  }

  public void add(String n, Object o){
    table.put((Object)n, o);
    list.addLast(o);
    last = last+1;
  }

  public void add(String n, Object o, int i){
    table.put((Object)n, o);
    last = last+1;
    for( int j=last ; j>i; j++) list.set(j,list.get(j-1));
    list.set(i,o);
  }

    public ListIterator listIterator(){
	return list.listIterator();
    }
    
    public Enumeration getKeys(){
	return table.keys();
    }


    public int getLength(){
	return last;
    }

    public int indexOf(Object o){
	return list.indexOf(o);
    }
    
    public void remove(String name){
	Object o = table.get(name);
	table.remove((Object)name);	
		
	for( int i=list.indexOf(o) ; i<last-1; i++) list.set(i,list.get(i+1));
	list.removeLast();
	last = last - 1;
	
  }

}

